/*  based on gngeo a neogeo emulator
 *  Copyright (C) 2001 Peponas Mathieu
 *  rewritten to 2 channel system for NeoDC
 *	Coypright (C) 2005 Donald Haase
 */
/*#define AICASTEREO*/

#include "../neocd.h"
#include "streams.h"
#include "sound.h"
#include <kos.h>
#include "aica.h"
#include <dc/spu.h>
/**************************************************************/
	int nextbuf=0;
	int paused;
/**************************************************************/
#define	SPU_RAM_BASE	0xa0800000
#define SPU_POS			0x11000
#define SPU_POS2		0x16000
/**************************************************************/
int sound=1;
extern u16 left_buffer[BUFFER_LEN/2]__attribute__((aligned(32)));
extern u16 right_buffer[BUFFER_LEN/2]__attribute__((aligned(32)));

void PauseAudio (int pause_on);
void play_audio(void);
static void dc_audio_callback(ptr_t data){
	play_audio();
}

void play_audio(void){
	
	if(aica_get_pos(0)/(SAMPLES) == nextbuf)	return;

#ifndef AICASTEREO	
	if (sound) {	
		streamupdatemono();
		dcache_flush_range((int)left_buffer, (BUFFER_LEN/2));
		spu_dma_transfer( (uint8 *)left_buffer, SPU_POS+(nextbuf*2*SAMPLES)	, (2*SAMPLES), 0, dc_audio_callback, 0);
	}
#else
		if (sound) {	
		
		streamupdate(BUFFER_LEN);
		dcache_flush_range((int)left_buffer, (BUFFER_LEN/2));
		spu_dma_transfer( (uint8 *)left_buffer, SPU_POS+(nextbuf*2*SAMPLES)	, (BUFFER_LEN/2), 0, dc_audio_callback, 0);
		//spu_memload(SPU_POS+(nextbuf*2*SAMPLES),(uint8 *) left_buffer, (BUFFER_LEN/2));
		spu_memload(SPU_POS2+(nextbuf*2*SAMPLES),(uint8 *)right_buffer,(BUFFER_LEN/2));
	}
#endif

	nextbuf^=1;
}

void init_audio(void)
{
    spu_init();

	spu_memset(SPU_POS, 0x00, BUFFER_LEN);	
#ifdef AICASTEREO
	spu_memset(SPU_POS2, 0x00, BUFFER_LEN);
	aica_play(1,0,SPU_POS2,0,BUFFER_LEN/2,22050,255,255,1);
	aica_play(0,0,SPU_POS ,0,BUFFER_LEN/2,22050,255,  0,1);
#else
	aica_play(0,0,SPU_POS ,0,BUFFER_LEN/2,22050,255,  128,1);
#endif
	
	
    streams_sh_start();
    YM2610_sh_start();
	sound_enable();
}

void sound_toggle(void) {
	PauseAudio(sound^1);	
}

void sound_enable(void) {
	PauseAudio(1);
}

void sound_disable(void) {
	PauseAudio(0);
}

void sound_shutdown(void) {
    PauseAudio(0);
	aica_stop(0);
	aica_stop(1);
    streams_sh_stop();
//    YM2610_sh_stop();
	YM2610Shutdown();			
}

void PauseAudio (int pause_on)
{
	if(!pause_on){
			spu_memset(SPU_POS, 0x00, BUFFER_LEN);
			#ifdef AICASTEREO
			spu_memset(SPU_POS2, 0x00, BUFFER_LEN);
			#endif
	}

	sound = pause_on;
}
